Attribute VB_Name = "ConsoleCommands"
Option Explicit
Const MODULE_NAME As String = "ConsoleCommands"

Public Function Console_Commands(Command As String) As Boolean
'/* Begin Error Handler
On Error GoTo HandleError
    Call mProcStack.EnterProc("Console_Commands", MODULE_NAME)

' commands
If Left(Command, 8) = "commands" Then
    If Left(Command, 11) = "commands /?" Then
        Console_Output "Lists all commands", 10, True, 2, True, 2, True, False, True, False
        Console_Commands = True
        Exit Function
    ElseIf Command = "commands" Then
        Console_Output "::: Commands :::", 5, True, 2, True, 1, False, False, True, False
        Console_Output "login [HOTEL], [USERNAME], [PASSWORD]", 10, False, 0, True, 1, False, False, True, False
        Console_Output "logout", 10, False, 0, True, 1, False, False, True, False
        Console_Output "SckClient.SendData [DATA]", 10, False, 0, True, 1, False, False, True, False
        Console_Output "SckServer.SendData [DATA]", 10, False, 0, True, 1, False, False, True, False
        Console_Output "exit", 10, False, 0, True, 2, False, False, True, False
        Console_Output "For Specified command help, type [COMMAND] /?", 10, False, 0, True, 2, True, False, True, False
        Console_Commands = True
        Exit Function
    Else: GoTo UnknowCommand
    End If
' login
ElseIf Left(Command, 6) = "login " Then
    If Left(Command, 8) = "login /?" Then
        Console_Output "Log into a hotel", 10, True, 2, True, 1, False, False, True, False
        Console_Output "Example: login http://www.habbo.ch, Habbo123, pass123", 10, False, 0, True, 2, True, False, True, False
        Console_Commands = True
        Exit Function
    End If
    'Only accept exactlly Command
    If StrCount(Command, ",") < 2 Then
    Exit Function
    End If
    If StrCount(Command, " ") < 3 Then
    Exit Function
    End If
    If StrCount(Command, "http://") < 1 Then
    Exit Function
    End If
    Dim Hotel As String
    Hotel = Split(Command, "login ")(1)
    Hotel = Split(Hotel, ",")(0)
    FrmMain.Hotel = Hotel
    Dim Username As String
    Username = Split(Command, ", ")(1)
    Username = Split(Username, ",")(0)
    FrmMain.Username = Username
    Dim Password As String
    Password = Split(Command, ", ")(2)
    Password = Split(Password, ",")(0)
    FrmMain.Password = Password
    Call LogIn(Hotel, Username, Password, False, False)
    Exit Function
' logout
ElseIf Left(Command, 6) = "logout" Then
    If Left(Command, 9) = "logout /?" Then
        Console_Output "Logout of the current connected hotel", 10, True, 2, True, 2, True, False, True, False
        Console_Commands = True
        Exit Function
    ElseIf Command = "logout" Then
        Call LogOut(True)
        Exit Function
    Else: GoTo UnknowCommand
    End If
ElseIf Left(Command, 19) = "SckServer.SendData " Then
    If Left(Command, 22) = "SckServer.SendData /?" Then
        Console_Output "Sends Data to the Server", 10, True, 2, True, 2, True, False, True, False
        Console_Commands = True
        Exit Function
    End If
        If FrmBrowser.SckServer.State <> sckConnected Then
        Console_Output "Can't send to SckServer -> Not connected", 10, True, 2, True, 2, True, False, True, True
        Console_Commands = True
        Exit Function
    Dim SckServerPacket As String
    SckServerPacket = Split(Command, " ,")(1)
        If Len(SckServerPacket) > 64 Then
        Console_Output "Can't send to SckServer -> Packetlength > 64", 10, True, 2, True, 2, True, False, True, True
        Console_Commands = True
        Exit Function
        End If
    FrmBrowser.SentData = True
        If FrmSettings.opt_encryption_18.Value = True Then
        FrmBrowser.SckServer.SendData FrmBrowser.RC4E_18.encipher(SckServerPacket)
        ElseIf FrmSettings.opt_encryption_23.Value = True Then
        FrmBrowser.SckServer.SendData FrmBrowser.RC4E_23.encipher(SckServerPacket)
        End If
    Console_Commands = True
    Exit Function
    End If
ElseIf Left(Command, 19) = "SckClient.SendData " Then
    If Left(Command, 22) = "SckClient.SendData /?" Then
        Console_Output "Sends Data to the Client", 10, True, 2, True, 2, True, False, True, False
        Console_Commands = True
        Exit Function
    End If
        If FrmBrowser.SckClient.State <> sckConnected Then
        Console_Output "Can't send to SckClient -> Not connected", 10, True, 2, True, 2, True, False, True, True
        Console_Commands = True
        Exit Function
        End If
    Dim SckClientPacket As String
    SckClientPacket = Split(Command, ", ")(1)
    FrmBrowser.SentData = True
    FrmBrowser.SckClient.SendData (SckClientPacket)
    Console_Commands = True
    Exit Function
ElseIf Left(Command, 4) = "exit" Then
    If Left(Command, 7) = "exit /?" Then
        Console_Output "Terminates the app", 10, True, 2, True, 2, True, False, True, False
        Console_Commands = True
        Exit Function
    ElseIf Command = "exit" Then
        Unload FrmMain
        Console_Commands = True
        Exit Function
    Else: GoTo UnknowCommand
    End If
ElseIf Command = "" Then
    Console_Output "", 10, True, 1, False, 0, True, False, True, False
    Console_Commands = False
    Exit Function
Else
UnknowCommand:
    Console_Output "Can't find the Command " & Chr(34) & Command & Chr(34) & " or it's wrong typed.", 10, True, 2, True, 2, True, False, True, False
    Console_Commands = False
    Exit Function
End If

'/* End Error Handler
Console_Commands_Done:
    Call mProcStack.ExitProc("Console_Commands")
    Exit Function

HandleError:
    Process_Error MODULE_NAME, Err, "Console_Commands"
    Resume Console_Commands_Done

End Function
