Attribute VB_Name = "PostHeader"
Private Declare Function InternetCloseHandle Lib "wininet.dll" ( _
    ByVal hInternetHandle As Long) As Boolean
Private Declare Function InternetConnectA Lib "wininet.dll" ( _
    ByVal hInternetSession As Long, ByVal lpszServerName As String, _
    ByVal nProxyPort As Integer, ByVal lpszUsername As String, _
    ByVal lpszPassword As String, ByVal dwService As Long, _
    ByVal dwFlags As Long, ByVal dwContext As Long) As Long
Private Declare Function InternetOpenA Lib "wininet.dll" ( _
    ByVal lpszCallerName As String, ByVal dwAccessType As Long, _
    ByVal lpszProxyName As String, ByVal lpszProxyBypass As String, _
    ByVal dwFlags As Long) As Long
Private Declare Function InternetReadFile Lib "wininet.dll" ( _
    ByVal hFile As Long, ByVal sBuffer As String, _
    ByVal lNumBytesToRead As Long, Bytes As Long _
  ) As Integer
Private Const INTERNET_FLAG_RELOAD = &H80000000
Private Const INTERNET_SERVICE_HTTP = 3

Private Declare Function HttpAddRequestHeadersA Lib "wininet.dll" ( _
    ByVal hHttpRequest As Long, ByVal sHeaders As String, _
    ByVal lHeadersLength As Long, _
    ByVal lModifiers As Long) As Integer
Private Declare Function HttpOpenRequestA Lib "wininet.dll" ( _
    ByVal hInternetSession As Long, ByVal lpszVerb As String, _
    ByVal lpszObjectName As String, ByVal lpszVersion As String, _
    ByVal lpszReferer As String, ByVal lpszAcceptTypes As Long, _
    ByVal dwFlags As Long, ByVal dwContext As Long) As Long
Private Declare Function HttpSendRequestA Lib "wininet.dll" ( _
    ByVal hHttpRequest As Long, ByVal sHeaders As String, _
    ByVal lHeadersLength As Long, ByVal sOptional As String, _
    ByVal lOptionalLength As Long) As Boolean
Private Const HTTP_ADDREQ_FLAG_ADD = &H20000000
Private Const HTTP_ADDREQ_FLAG_REPLACE = &H80000000

'Anwendungs-spezifisches:
Private Const INET_CallerName = "VB-Tec:INET"
Private Const INET_ContentType = _
    "Content-Type: application/x-www-form-urlencoded" & vbCrLf

'Enumeration fr Internet:
Public Enum InternetOpenType
  IOTPreconfig = 0
  IOTDirect = 1
  IOTProxy = 3
End Enum

Public Function HttpPost( _
    ByVal URL As String, _
    Optional ByRef Data As String, _
    Optional ByVal OpenType As InternetOpenType = IOTPreconfig, _
    Optional ByVal Port As Integer = 80, _
    Optional ByVal Username As String, _
    Optional ByVal Password As String _
  ) As String
  Dim Server As String
  Dim Path As String
  Dim hOpen As Long
  Dim hConnect As Long
  Dim hRequest As Long
  Dim Buffer As String * 2048
  Dim Bytes  As Long
  Dim i As Long
  
  'Server und Pfad bestimmen:
  URL = Trim$(URL)
  If LCase$(Left$(URL, 7)) = "http://" Then _
      URL = Mid$(URL, 8)
  i = InStr(URL, "/")
  If i > 0 Then
    'Server und Pfad trennen:
    Server = Left$(URL, i - 1)
    Path = Mid$(URL, i)
  Else
    'Root-Pfad verwenden:
    Server = URL
    Path = "/"
  End If
  
  'Internet-Handles ffnen:
  hOpen = InternetOpenA( _
      INET_CallerName, OpenType, _
      vbNullString, vbNullString, 0)
  hConnect = InternetConnectA( _
      hOpen, Server, Port, Username, Password, _
      INTERNET_SERVICE_HTTP, 0, 0)
  hRequest = HttpOpenRequestA( _
      hConnect, "POST", Path, "HTTP/1.0", _
      vbNullString, 0, INTERNET_FLAG_RELOAD, 0)
  
  'Header (mitsamt Daten) senden:
  HttpAddRequestHeadersA _
      hRequest, INET_ContentType, Len(INET_ContentType), _
      HTTP_ADDREQ_FLAG_REPLACE Or HTTP_ADDREQ_FLAG_ADD
  HttpSendRequestA _
      hRequest, vbNullString, 0, Data, Len(Data)
  
  'Ergebnis-Daten sammeln:
  Do
    InternetReadFile hRequest, Buffer, Len(Buffer), Bytes
    If Bytes = 0 Then Exit Do
    HttpPost = HttpPost & Left$(Buffer, Bytes)
  Loop
  
  'Internet-Handles schlieen:
  InternetCloseHandle hRequest
  InternetCloseHandle hConnect
  InternetCloseHandle hOpen
End Function

